#ifndef lint
static char *RCSid = "$Header: /usr/brule/guest/empire/empire/emprcs/lib/update/mobility.c,v 2.1 1995/07/27 20:50:10 empire Exp $";
#endif

/*
 * mobility.c
 *
 * Add mobility to each of the items which accumlate mobility.
 * 
 * Dave Pare, 1986
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "ship.h"
#include "land.h"
#include "plane.h"
#include "nat.h"
#include "file.h"
#include "optlist.h"
#include "mission.h"

#ifdef MOB_ACCESS

extern int timestamp_fixing;
extern int update_pending;
int do_upd_checking = 0;

increase_mob(counter, mult)
time_t *counter;
float mult;
{
    time_t secs;
    time_t now;
    time_t left;
    extern long s_p_etu;
    extern int updating_mob;
    int newetus;
    float newmob;
    int   inewmob;

    time(&now);

    secs = now - *counter;
    if (secs < 1 || secs < s_p_etu)
        return 0;
    newetus = (int)(secs / s_p_etu); 
    if (newetus < 1)
	return 0;
    left = (secs % s_p_etu);
    do {
      newmob = (float)(newetus * mult);
      inewmob = (int)(newetus * mult);
      if (newmob == inewmob || newetus > 7)
        break;
      newetus--;
      left += s_p_etu;
    } while (newetus > 0);
    if (newetus <= 0)
      return 0;

    time(counter);
    *counter = *counter - left;

    if (updating_mob)
      return (newetus);
    return 0;
}

update_timestamps(offset)
time_t offset;
{
  struct shpstr *shipp;
  struct sctstr *sectp;
  struct lndstr *landp;
  struct plnstr *planep;
  int n;
  time_t now;
  time_t delta;

  timestamp_fixing = 1;
  time(&now);
  delta = now - offset; 
  for (n = 0; shipp = getshipp(n); n++)
    shipp->shp_access += delta;
  for (n = 0; sectp = getsectid(n); n++)
    sectp->sct_access += delta;
  for (n = 0; landp = getlandp(n); n++)
    landp->lnd_access += delta;
  for (n = 0; planep = getplanep(n); n++)
    planep->pln_access += delta;
  timestamp_fixing = 0;
}

update_all_mob()
{
  struct shpstr *shipp;
  struct sctstr *sectp;
  struct lndstr *landp;
  struct plnstr *planep;
  int n;

  n = 0;
  while (1) {
    do_upd_checking = 1;
    shipp = getshipp(n);
    sectp = getsectid(n);
    landp = getlandp(n);
    planep = getplanep(n);
    do_upd_checking = 0;
    if (shipp)
      shp_do_upd_mob(shipp);
    if (sectp)
      sct_do_upd_mob(sectp);
    if (landp)
      lnd_do_upd_mob(landp);
    if (planep)
      pln_do_upd_mob(planep);
    if (!shipp && !sectp && !landp && !planep)
      break;
    n++;
  }
  do_upd_checking = 0;
}

sct_do_upd_mob(sp)
register struct sctstr *sp;
{
    extern float sect_mob_scale;
    int etus;

    if (do_upd_checking || timestamp_fixing)
        return;
    if (sp->sct_own == 0)
        return;
    if (sp->sct_type == SCT_SANCT)
        return;
    if ((etus = increase_mob(&sp->sct_access, sect_mob_scale)) == 0)
	return;
    do_upd_checking = 1;
    do_mob_sect(sp, etus);
/*    putsect(sp);*/
    do_upd_checking = 0;
}

shp_do_upd_mob(sp)
register struct shpstr *sp;
{
    extern float ship_mob_scale;
    int etus;

    if (do_upd_checking || timestamp_fixing || update_pending)
        return;
    if (sp->shp_own == 0)
        return;
    if ((etus = increase_mob(&sp->shp_access, ship_mob_scale)) == 0)
        return;
    do_upd_checking = 1;
    do_mob_ship(sp, etus);
    do_upd_checking = 0;
}

lnd_do_upd_mob(lp)
register struct lndstr *lp;
{
    extern float land_mob_scale;
    int etus;

    if (do_upd_checking || timestamp_fixing || update_pending)
        return;
    if (lp->lnd_own == 0)
        return;
    if ((etus = increase_mob(&lp->lnd_access, land_mob_scale)) == 0)
        return;

    do_upd_checking = 1;
    do_mob_land(lp, etus);
    do_upd_checking = 0;
}

pln_do_upd_mob(pp)
register struct plnstr *pp;
{
    extern float plane_mob_scale;
    int etus;

    if (do_upd_checking || timestamp_fixing || update_pending)
        return;
    if (pp->pln_own == 0)
        return;
    if ((etus = increase_mob(&pp->pln_access, plane_mob_scale)) == 0)
        return;

    do_upd_checking = 1;
    do_mob_plane(pp, etus);
    do_upd_checking = 0;
}

#endif MOB_ACCESS

mob_sect(etus)
        register int etus;
{
        register struct sctstr *sp;
        register int n;

        for (n=0; sp = getsectid(n); n++) {
#ifdef MOB_ACCESS
	        sct_do_upd_mob(sp);
#else
                do_mob_sect(sp, etus);
#endif /* MOB_ACCESS */
        }
}

do_mob_sect(sp, etus)
register struct sctstr *sp;
register int etus;
{
        extern  float sect_mob_scale;
        extern  int sect_mob_max;
        register int value;

    if (sp->sct_own == 0)
        return;
    if (sp->sct_type == SCT_SANCT)
        return;
    value = sp->sct_mobil + ((float)etus * sect_mob_scale);
    if (value > sect_mob_max)
        value = sect_mob_max;
    sp->sct_mobil = value;
}

mob_ship(etus)
    register int etus;
{
        register struct shpstr *sp;
        register int n;

        for (n=0; sp = getshipp(n); n++) {
#ifdef MOB_ACCESS
	    shp_do_upd_mob(sp);
#else
            do_mob_ship(sp, etus);
#endif /* MOB_ACCESS */
        }
}

do_mob_ship(sp, etus)
register struct shpstr *sp;
register int etus;
{
    extern  int ship_mob_max;
    extern  float ship_mob_scale;
    int     newfuel=0;
    register int value;
    register int n;
    int     can_add,have_fuel_for,total_add;
    double  d;
    extern  int fuel_mult;

    if (sp->shp_own == 0)
        return;


    if (opt_FUEL == 0) { /* only a bit to do ... */
        value = sp->shp_mobil + ((float)etus * ship_mob_scale);
        if (value > ship_mob_max)
            value = ship_mob_max;
        sp->shp_mobil = value;
        return; /* so we ship the FUEL stuff */
    }

    /* opt_FUEL in force */
    if (mchr[sp->shp_type].m_fuelu == 0) {
        value = sp->shp_mobil + ((float)etus * ship_mob_scale);
        if (value > ship_mob_max)
            value = ship_mob_max;
        sp->shp_mobil = (s_char)value;
    } else {
        can_add = ship_mob_max - sp->shp_mobil;
        if (can_add > ((float)etus*ship_mob_scale))
            can_add = ((float)etus*ship_mob_scale);
        have_fuel_for = ldround((((double)sp->shp_fuel /
                                  (double)mchr[sp->shp_type].m_fuelu)*
                                 (double)fuel_mult),1);

        if (can_add > have_fuel_for){
            int     need;
            need = can_add - have_fuel_for;
            d = (double)need;
            d *= (double)mchr[sp->shp_type].m_fuelu;
            d /= (double)fuel_mult;
            d /= 5.0;
            if ((d-(int)d) > 0.0)
                d++;
            need = (int)d;
            newfuel = supply_commod(sp->shp_own,sp->shp_x,
                                    sp->shp_y,I_PETROL,need);
            sp->shp_fuel += (u_char)(newfuel * 5);
        }

        have_fuel_for = ldround((((double)sp->shp_fuel /
                                  (double)mchr[sp->shp_type].m_fuelu)*
                                 (double)fuel_mult),1);

        if (can_add > have_fuel_for){
            int     need;
            need = can_add - have_fuel_for;
            d = (double)need;
            d *= (double)mchr[sp->shp_type].m_fuelu;
            d /= (double)fuel_mult;
            d /= 50.0;
            if ((d-(int)d) > 0.0)
                d++;
            need = (int)d;
            newfuel = supply_commod(sp->shp_own,sp->shp_x,
                                    sp->shp_y,I_OIL,need);
            sp->shp_fuel += (u_char)(newfuel * 50);
        }

        have_fuel_for = ldround((((double)sp->shp_fuel /
                                  (double)mchr[sp->shp_type].m_fuelu)*
                                 (double)fuel_mult),1);

        if (can_add > have_fuel_for)
            total_add = have_fuel_for;
        else
            total_add = can_add;
        d = (double)total_add;
        d *= (double)mchr[sp->shp_type].m_fuelu;
        d /= (double)fuel_mult;
        sp->shp_fuel -= (u_char)ldround(d,1);
        sp->shp_fuel = (u_char)min(sp->shp_fuel,
                           mchr[sp->shp_type].m_fuelc);
        sp->shp_mobil += (s_char)total_add;
    }
}

mob_land(etus)
        register int etus;
{
        register struct lndstr *lp;
        register int n;

        for (n=0; lp = getlandp(n); n++) {
#ifdef MOB_ACCESS
	    lnd_do_upd_mob(lp);
#else
            do_mob_land(lp, etus);
#endif MOB_ACCESS
        }
}

do_mob_land(lp, etus)
register struct lndstr *lp;
register int etus;
{
    extern  int land_mob_max;
    extern  float land_mob_scale;
    int     newfuel=0;
    register int value;
    int     can_add,have_fuel_for,total_add;
    double  d;
    extern  int fuel_mult;
    int fort = 0;
    
    if (lp->lnd_own == 0)
        return;
    
    /*
     * Give damaged units a break. When at low
     * efficiency, units can go to -100 mob when
     * marching 1 step, making them slower than
     * normal mil. This helps take the curse off.
     * If MOB_ACCESS is on, we don't do this, as it would
     * be too much of an advantage.  So, we just add double
     * the small amount of mob if we are < 0 instead.
     */
    
#ifndef MOB_ACCESS
    if (lp->lnd_mobil < 0)
        lp->lnd_mobil /= 2;
#endif /* MOB_ACCESS */
    
    if (opt_FUEL == 0) { /* just some bits and pieces */
#ifdef MOB_ACCESS
	if (lp->lnd_mobil < 0)
	    value = lp->lnd_mobil + (2 * ((float)etus * land_mob_scale));
	else
	    value = lp->lnd_mobil + ((float)etus * land_mob_scale);
#else
	value = lp->lnd_mobil + ((float)etus * land_mob_scale);
#endif /* MOB_ACCESS	     */
        if (value > land_mob_max) {
	    fort = value - land_mob_max;
            value = land_mob_max;
	}
        lp->lnd_mobil = value;
	lp->lnd_harden = min((int)lp->lnd_harden + fort, 127);
        return; /* Done! */
    }
    
    /* opt_FUEL in force ... */
    if (lchr[lp->lnd_type].l_fuelu == 0){
#ifdef MOB_ACCESS
	if (lp->lnd_mobil < 0)
	    value = lp->lnd_mobil + (2 * ((float)etus * land_mob_scale));
	else
	    value = lp->lnd_mobil + ((float)etus * land_mob_scale);
#else
	value = lp->lnd_mobil + ((float)etus * land_mob_scale);
#endif /* MOB_ACCESS	     */
        if (value > land_mob_max) {
	    fort = value - land_mob_max;
	    value = land_mob_max;
	}
        lp->lnd_mobil = value;
	lp->lnd_harden = min((int)lp->lnd_harden + fort,127);

    } else {
	
        if(((struct natstr *)getnatp(lp->lnd_own))->nat_flags & NF_FORT) {
	    can_add = land_mob_max - lp->lnd_mobil + 127 - lp->lnd_harden;
	}
	else
	    can_add = land_mob_max - lp->lnd_mobil;
	
        if (can_add > ((float)etus*land_mob_scale))
            can_add = ((float)etus*land_mob_scale);

        have_fuel_for = (lp->lnd_fuel /
                         lchr[lp->lnd_type].l_fuelu)*fuel_mult;

        if (can_add > have_fuel_for){
            int     need;
            need = can_add - have_fuel_for;
            d = (double)need;
            d *= (double)lchr[lp->lnd_type].l_fuelu;
            d /= (double)fuel_mult;
            d /= 5.0;
            if ((d-(int)d) > 0.0)
                d++;
            need = (int)d;
            newfuel = supply_commod(lp->lnd_own,lp->lnd_x,
                                    lp->lnd_y,I_PETROL,need);
            lp->lnd_fuel += (u_char)(newfuel * 5);
        }

        have_fuel_for = (lp->lnd_fuel /
                         lchr[lp->lnd_type].l_fuelu)*fuel_mult;

        if (can_add > have_fuel_for){
            int     need;
            need = can_add - have_fuel_for;
            d = (double)need;
            d *= (double)lchr[lp->lnd_type].l_fuelu;
            d /= (double)fuel_mult;
            d /= 50.0;
            if ((d-(int)d) > 0.0)
                d++;
            need = (int)d;
            newfuel = supply_commod(lp->lnd_own,lp->lnd_x,
                                    lp->lnd_y,I_OIL,need);
            lp->lnd_fuel += (u_char)(newfuel * 50);
        }

        have_fuel_for = (lp->lnd_fuel /
                         lchr[lp->lnd_type].l_fuelu)*fuel_mult;

        if (can_add > have_fuel_for){
            total_add = have_fuel_for;
        }
        else
            total_add = can_add;
        d = (double)total_add;
        d *= (double)lchr[lp->lnd_type].l_fuelu;
        d /= (double)fuel_mult;
        lp->lnd_fuel -= (u_char)ldround(d,1);
        lp->lnd_fuel = (u_char)min(lp->lnd_fuel,
                           lchr[lp->lnd_type].l_fuelc);
	if(total_add + lp->lnd_mobil > land_mob_max) {
	    fort = total_add + lp->lnd_mobil - land_mob_max;
	    total_add = land_mob_max - lp->lnd_mobil;
	}
	
	lp->lnd_harden = min((int)lp->lnd_harden + fort,127);
#ifdef MOB_ACCESS
	if (lp->lnd_mobil < 0)
	    lp->lnd_mobil += (s_char)total_add;
#endif /* MOB_ACCESS */
        lp->lnd_mobil += (s_char)total_add;
    }
}

mob_plane(etus)
        register int etus;
{
        register struct plnstr *pp;
        register int n;

        for (n=0; pp = getplanep(n); n++) {
#ifdef MOB_ACCESS
	    pln_do_upd_mob(pp);
#else
            do_mob_plane(pp, etus);
#endif /* MOB_ACCESS */
        }
}

do_mob_plane(pp, etus)
register struct plnstr *pp;
register int etus;
{
    extern  int plane_mob_max;
    extern  float plane_mob_scale;
    register int value;

    if (pp->pln_own == 0)
        return;

    value = pp->pln_mobil + ((float)etus * plane_mob_scale);
    if (value > plane_mob_max)
        value = plane_mob_max;
    pp->pln_mobil = value;
}
